=== debian/changelog ===
mumble (1.5.517-1ubuntu2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 17:55:23 +1100

mumble (1.5.517-1ubuntu1) noble; urgency=medium

  * d/t/smoke: fix syntax error (missing closing paren)

 -- Simon Chopin <schopin@ubuntu.com>  Wed, 27 Mar 2024 20:22:00 +0100

mumble (1.5.517-1build2) noble; urgency=medium

  * No-change rebuild against libqt5core5t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 15 Mar 2024 05:59:25 +0000

mumble (1.5.517-1build1) noble; urgency=medium

  * No-change rebuild against libssl3t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Mon, 04 Mar 2024 20:02:49 +0000

mumble (1.5.517-1) unstable; urgency=medium

  [ Sven Hartge ]
  * debian/patches:
    - Add 90-debianize-systemd-unit.diff to get systemd service file working
      (Closes: #1039271)
  * Update files under debian/ for renaming murmurd -> mumble-server:
    - mumble-server.README.Debian
    - mumble-server.postinst
    - mumble-server.templates
    - po/cs.po
    - po/da.po
    - po/de.po
    - po/es.po
    - po/eu.po
    - po/fi.po
    - po/fr.po
    - po/gl.po
    - po/hu.po
    - po/it.po
    - po/ja.po
    - po/nb.po
    - po/nl.po
    - po/pt.po
    - po/pt_BR.po
    - po/ru.po
    - po/sv.po
    - po/templates.pot
    - po/vi.po
  * Fix permissions for /etc/mumble on upgrade and new installation; updates:
    - mumble-server.postinst
    - mumble-server.preinst

  [ Christopher Knadle ]
  * New upstream release candidate snapshot from 2023-01-21
    https://www.mumble.info/blog/mumble-1.5.517-rc/
    (Several attempts to release 1.4.x were made but did not work out)
    (Closes: #1017780)
  * debian/compat:
    - File removed; debhelper compatibility set via debhelper-compat
  * debian/control:
    - Update dependencies for 1.5.x release
    - Set debhelper compatibility via debhelper-compat
    - Change Maintainer field to the Debian VoIP Team
    - Add Rules-Requires-Root: no to allow building as non-root
    - Update Standards-Version to 4.6.2 (no changes needed)
  * debian/copyright:
    - Update for 3rdparty license changes in 1.5.x
  * debian/mumble.docs:
    - Update for files available in release
  * debian/mumble.lintian-overrides:
    - Remove all overrides, none seem to apply
  * debian/mumble-server.docs:
    - Update for new file locations
  * debian/mumble-server.doc-base:
    - Update for new file locations
  * debian/mumble.install:
    - Update for file location changes and removal of .protocol file
  * debian/mumble-server.install:
    - Update for new file locations
  * debian/mumble.manpages:
    - Update for new build file locations
  * debian/mumble-server.manpages:
    - Update for new build file locations
  * debian/mumble-server.postinst:
    - Update for configuration file move from /etc to /etc/mumble
  * debian/mumble.README.Debian:
    - Add new README to help introduce the Mumble client, hints for testing
      setups,and to give some instructions on using Mumble over Tor
  * debian/mumble-server.README.Debian:
    - Update README for important new changes with 1.5.517
    - Add new section describing how to set up a Tor Onion Service for
      mumble-server to allow running a mumble service over Tor
  * debian/NEWS:
    - Add entry to warn users of dropping of all codecs other than OPUS and
      links to a summary of changes and chat window scrolling issue on Linux
    - Notify that README.Debian files now have documentation for using mumble
      and mumble-server over Tor.
  * debian/patches:
    - Remove 06-lsb-lower-dbus-dependency.diff; patch incorporated into init
      script shipped as examples for users using alternate init systems
    - Remove 07-use-embedded-celt-baseline.diff: obsolete, CELT support removed
    - Update 12-disable-ice-by-default.diff for new config file location
    - Remove 25-make-logfiles-readable-by-adm.diff; patch incorporated into
      shipped logrotate example in examples for users of alternate init systems
    - Remove 44-add-speechd-header.diff; obsolete, file patch points to removed
    - Add 45-add-pid-location-hint.diff patch to suggest a pidfile location
      in mumble-server.ini for when using an alternate init system and an
      init script
    - Remove 46-var-run-to-run.diff: obsolete patch and incorporated into
      shipped example files
    - Remove 52-use-update-rc.d-for-disable.diff; obsolete patch, incorporated
      into shipped example init script
    - Remove 54-fix-mysql-start.diff; obsolete patch, incorporated into shipped
      example init script
    - Remove 55-openssl-3.0-compat.patch; obsolete patch
  * debian/rules:
    - Strip LDFLAGS for options that would break mumble_overlay
    - Switch to building with cmake
    - Added cmake options for building Mumble release on Debian
    - Removed section installing CHANGES file (file removed from release)
    - Build Ice HTML files based on MumbleServer.ice in new location
  * debian/source/lintian-overrides:
    - Remove override source-is-missing for removed html file
  * debian/upstream/signing-key.asc:
    - Update to Mumble 2023 build infrastructure key
  * debian/tests:
    - Add autopkgtest 'smoke' test to execute mumble and mumble-server and
      get text output of version
  * debian/watch:
    - Update to upstream snapshot directory so uscan can find 1.5.517 tarball

 -- Christopher Knadle <Chris.Knadle@coredump.us>  Tue, 02 Jan 2024 23:13:08 -0500
