=== debian/watch ===
version=4
opts="\
	repack, \
	repacksuffix=+dfsg, \
	dversionmangle=s/(\da?)[\+\.\-~](?:dfsg|debian|ds|repack|repacked)\.?\d*$/$1/, \
	pgpsigurlmangle=s/$/.(?:sig|asc)/"
https://dl.mumble.info/snapshot/mumble-(\d+\.\d+\.\d+)\.tar\.gz
